#!/usr/bin/env python

import re
from collections import OrderedDict

def read_gtfLines(infile_fasta_fn):
    linesTMP = open(infile_fasta_fn, "r")
    lines = list(linesTMP)
    linesTMP.close()
    recordsFN = []
    for line in lines:
        line = line.rstrip("\n")
        if line.startswith("#"):
            continue
        elements = line.split("\t")
        geneID = elements[0]
        chrom = elements[1]
        strand = elements[2]
        txStart = elements[3]
        txEnd = elements[4]
        name2 = elements[5]
        #print(elements)
        recordsFN.append([geneID, chrom, strand, txStart, txEnd, name2])
    return recordsFN

def select_TSS_2(stock_recs_fn):
    strand_fn = stock_recs_fn[0][2]
    TSS = ""
    transcript_ID = ""
    gene_name = ""
    chromosome = ""
    if strand_fn == "+":
        rec_lists_fn2 = sorted(stock_recs_fn, key=lambda x: x[3])
        TSS = rec_lists_fn2[0][3]
        transcript_ID = rec_lists_fn2[0][0]
        gene_name = rec_lists_fn2[0][5]
        chromosome = rec_lists_fn2[0][1]
    else:
        rec_lists_fn2 = sorted(stock_recs_fn, key=lambda x: x[4])
        TSS = rec_lists_fn2[-1][4]
        transcript_ID = rec_lists_fn2[-1][0]
        gene_name = rec_lists_fn2[-1][5]
        chromosome = rec_lists_fn2[-1][1]
    #for rec_list in stock_recs_fn:
    #    print (rec_list)
    chromosome = re.sub("chr", "", chromosome)
    
    #print("transcript_ID", transcript_ID)
    #print("gene_name", gene_name)
    #print("chromosome", chromosome)
    #print("TSS", TSS)
    #print("\n")
    return transcript_ID, gene_name, chromosome, TSS

def print_martstyle(lists_martstyle):
    out = open(outfile, "w")
    out.write("name\tname2\tchrom\tTSS\n")
    for line in lists_martstyle:
        out.write(line[0] + "\t" + line[1] + "\t" + line[2] + "\t" + line[3] + "\n")
    out.close()

def select_TSS(rec_lists):
    name2_prev = ""
    stock_recs = []
    flag = 0
    lists_martstyle = []
    for rec_list in rec_lists:
        #print(rec_list)
        geneID = rec_list[0]
        chrom = rec_list[1]
        strand = rec_list[2]
        txStart = rec_list[3]
        txEnd = rec_list[4]
        name2 = rec_list[5]
        #print("name2", name2, "|")
        #print("name2_prev", name2_prev, "|")
        if name2_prev != name2:
            if flag == 0:
                flag = 1
                name2_prev = name2
                stock_recs.append(rec_list)
                continue
            else:
                transcript_ID, gene_name, chromosome, TSS = select_TSS_2(stock_recs)
                lists_martstyle.append([transcript_ID, gene_name, chromosome, TSS])
                stock_recs = []
        name2_prev = name2
        stock_recs.append(rec_list)
    transcript_ID, gene_name, chromosome, TSS = select_TSS_2(stock_recs)
    lists_martstyle.append([transcript_ID, gene_name, chromosome, TSS])
    lists_martstyle = sorted(lists_martstyle, key=lambda x: (x[2], int(x[3])))
    print_martstyle(lists_martstyle)

def sort_by_geneName(rec_lists_fn):
    rec_lists_fn = sorted(rec_lists_fn, key=lambda x: x[5])
    return rec_lists_fn


def get_unique_genename(rec_lists):
    rec_lists2_dic = {}
    for rec_list in rec_lists:
        geneID = rec_list[0]
        chrom = rec_list[1]
        strand = rec_list[2]
        txStart = rec_list[3]
        txEnd = rec_list[4]
        name2 = rec_list[5]
        rec_lists2_dic[name2] = 1
    return rec_lists2_dic.keys()



######## Main program
infile_gtf = "UCSC.test.gtf"
#infile_gtf = "UCSC.hg38.gtf"

outfile = "mart-export-out_mart-export-out_Homo-sapiens-hg38-UCSC.txt"

rec_lists = read_gtfLines(infile_gtf)
rec_lists = sort_by_geneName(rec_lists)
count = 0
#for rec in rec_lists:
#    count += 1
#    print(count, rec)
#print("\n")
select_TSS(rec_lists)

exit()

#rec_lists2_dic = get_unique_genename(rec_lists)

